SELECT
  S.NOME AS SETOR
  , an.numero as MATRIZ
  , AN.DTNASCIMENTO AS NASCIMENTO
  , ia.data as data_ia
  , iatf.descricao as protocolo_utilizado
  , (case when (next.cdtiporeproducao in (1,2,3)) then NEXT."DATA" when (next.diagnostico = 'N') then NEXT."DATA"
        when (next.diagnostico = 'P') then NEXT."DATA" when (next.cio in (1,2)) then NEXT."DATA" else null end) as diagnostico
  , (case when (next.cdtiporeproducao in (1,2,3)) then 'Negativo' when (next.diagnostico = 'N') then 'Negativo' 
        when (next.diagnostico = 'P') then 'Positivo' when (next.cio in (1,2)) then 'Negativo' else null end) as diagnostico
  , par.data as data_parto
  , COALESCE(TOU.NUMERO, AR.DESCRICAO) AS REPRODUTOR
  , bez.numero as BEZERRO
  , bez.DTDESMAMA AS DESMAMA
  , COALESCE((SELECT PESO FROM PESO WHERE CDANIMAL = bez.CDANIMAL AND CDTIPOPESO = 3), (SELECT PESO FROM PESO WHERE CDANIMAL = bez.CDANIMAL AND BEZ.DTDESMAMA = DTPESO)) AS PESO_DESMAMA
from
    reproducao ia
    left join protocoloiatf iatf on iatf.cdprotocoloiatf = ia.cdprotocoloiatf
    left join reproducao next on next.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.data>ia.data and
        ((re.cdtiporeproducao in (1,2,3)) or (re.diagnostico = 'N') or (re.diagnostico = 'P') or (re.cio in (1,2)))
        order by re.data)
    left join reproducao par on par.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.cdtiporeproducao =
            7 and re.data > ia.data and not exists (select * from reproducao ree where ree.cdanimal = re.cdanimal and
            ree.data > ia.data and ree.data < re.data and ((ree.cdtiporeproducao in (1,2,3)) or (ree.diagnostico = 'N')
            or (ree.cio in (1,2)))) order by re.data desc)
    join animal an on an.cdanimal = ia.cdanimal
    left join animal bez on bez.cdreproducao = par.cdreproducao
    left join animal pai on pai.cdanimal = bez.cdpai
    LEFT JOIN SETOR S ON S.CDSETOR = AN.CDSETOR
    LEFT JOIN ANIMAL TOU ON TOU.CDANIMAL = IA.CDREPRODUTOR
    LEFT JOIN RACA AR ON AR.CDRACA = IA.CDRACA
WHERE
  IA.CDTIPOREPRODUCAO IN (1, 2, 3)
  AND ia.data between '2015-01-01' and '2015-12-31'